> For the complete documentation index, see [llms.txt](https://docs.redivis.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.redivis.com/api/client-libraries/redivis-js/reference/file.md).

# File

## *class* <mark style="color:purple;">File</mark>

A non-tabular file on Redivis, belonging to a [file index table](https://docs.redivis.com/reference/datasets/files) (or referenced by a query's results). Files can be read into memory, streamed, or downloaded.

## Constructors

| Method                                                                                                                                         | Description                                                                                                                            |
| ---------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------- |
| [**`Table.file`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/table/table.file.md)(path)                               | Return the File at a path within a file index table.                                                                                   |
| [**`Table.listFiles`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/table/table.listfiles.md)(\[maxResults, options])   | List the Files in a file index table.                                                                                                  |
| [**`Query.file`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/table/table.file.md)(path)                               | Return the File at a path within a query's results.                                                                                    |
| [**`Query.listFiles`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/table/table.listfiles.md)(\[maxResults, options])   | List the Files referenced by a query's results.                                                                                        |
| [**`Directory.get`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/directory/directory.get.md)(path)                     | Return the File at a path within a [Directory](https://docs.redivis.com/api/client-libraries/redivis-js/reference/directory.md).       |
| [**`Directory.list`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/directory/directory.list.md)(\[maxResults, options]) | List the Files (and subdirectories) of a [Directory](https://docs.redivis.com/api/client-libraries/redivis-js/reference/directory.md). |

## Examples

```javascript
// See https://redivis.com/datasets/yz1s-d09009dbb/files for example data
const table = redivis.table('demo.example_data_files:yz1s:v1_3.example_file_types:4c10');
const textFile = await table.file('pandas_core.py');
const imageFile = await table.file('bogota.tiff');

// Read file contents
const text = await textFile.read({ asText: true });
const bytes = await imageFile.read(); // A Uint8Array
const firstBytes = await imageFile.read({ startByte: 0, endByte: 99 }); // The first 100 bytes

// Stream the file's contents (e.g., to a WritableStream)
await textFile.stream().pipeTo(writableStream);

// In the browser, display an image
const blob = await new Response(imageFile.stream()).blob();
img.src = URL.createObjectURL(blob);

// Download the file (Node.js only)
await imageFile.download('./path/'); // Downloaded as ./path/bogota.tiff
await textFile.download('./path/renamed.txt'); // Downloaded as ./path/renamed.txt
```

## Attributes

| Name             | Description                                                                                                                                                |
| ---------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **`id`**         | The file's id.                                                                                                                                             |
| **`name`**       | The file's name, e.g. `a.png`.                                                                                                                             |
| **`path`**       | The file's path within its table, e.g. `images/a.png`.                                                                                                     |
| **`size`**       | The file's size, in bytes.                                                                                                                                 |
| **`md5Hash`**    | The base64-encoded MD5 hash of the file's contents.                                                                                                        |
| **`addedAt`**    | When the file was added to its table.                                                                                                                      |
| **`directory`**  | The [Directory](https://docs.redivis.com/api/client-libraries/redivis-js/reference/directory.md) that contains the file, if it was listed via a directory. |
| **`table`**      | The [Table](https://docs.redivis.com/api/client-libraries/redivis-js/reference/table.md) that the file belongs to, if any.                                 |
| **`query`**      | The [Query](https://docs.redivis.com/api/client-libraries/redivis-js/reference/query.md) that the file belongs to, if any.                                 |
| **`properties`** | An object containing the file's metadata, as listed in its table.                                                                                          |

## Methods

| Method                                                                                                                            | Description                                       |
| --------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------- |
| [**`File.download`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/file/file.download.md)(\[path, options]) | Download the file (Node.js only).                 |
| [**`File.read`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/file/file.read.md)(\[options])               | Read the file's contents into memory.             |
| [**`File.stream`**](https://docs.redivis.com/api/client-libraries/redivis-js/reference/file/file.stream.md)(\[options])           | Return a `ReadableStream` of the file's contents. |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.redivis.com/api/client-libraries/redivis-js/reference/file.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
